| Flutter Impeller |

Classes | Public Types | Public Member Functions | Static Public Member Functions | List of all members
impeller::Contents Class Referenceabstract

`#include <contents.h>`

Inheritance diagram for impeller::Contents:

## Classes
struct | ClipCoverage

## Public Types
using | ColorFilterProc = std::function< Color(Color)>
using | RenderProc = std::function< bool(const ContentContext &renderer, const Entity &entity, RenderPass &pass)>
using | CoverageProc = std::function< std::optional< Rect >(const Entity &entity)>

## Public Member Functions
| Contents ()
virtual | ~Contents ()
virtual bool | Render (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const =0
virtual std::optional< Rect > | GetCoverage (const Entity &entity) const =0
| Get the area of the render pass that will be affected when this contents is rendered. More...
void | SetCoverageHint (std::optional< Rect > coverage_hint)
| Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`. More...
const std::optional< Rect > & | GetCoverageHint () const
virtual bool | IsOpaque (const Matrix &transform) const
| Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity. More...
virtual ClipCoverage | GetClipCoverage (const Entity &entity, const std::optional< Rect > &current_clip_coverage) const
| Given the current pass space bounding rectangle of the clip buffer, return the expected clip coverage after this draw call. This should only be implemented for contents that may write to the clip buffer. More...
virtual std::optional< Snapshot > | RenderToSnapshot (const ContentContext &renderer, const Entity &entity, std::optional< Rect > coverage_limit=std::nullopt, const std::optional< SamplerDescriptor > &sampler_descriptor=std::nullopt, bool msaa_enabled=true, int32_t mip_count=1, const std::string &label="Snapshot") const
| Render this contents to a snapshot, respecting the entity's transform, path, clip depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`. More...
std::optional< Size > | GetColorSourceSize () const
| Return the color source's intrinsic size, if available. More...
void | SetColorSourceSize (Size size)
virtual void | SetInheritedOpacity (Scalar opacity)
| Inherit the provided opacity. More...
virtual std::optional< Color > | AsBackgroundColor (const Entity &entity, ISize target_size) const
| Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation. More...
virtual const FilterContents * | AsFilter () const
| Cast to a filter. Returns `nullptr` if this Contents is not a filter. More...
virtual bool | ApplyColorFilter (const ColorFilterProc &color_filter_proc)
| If possible, applies a color filter to this contents inputs on the CPU. More...

## Static Public Member Functions
static std::shared_ptr< Contents > | MakeAnonymous (RenderProc render_proc, CoverageProc coverage_proc)

## Detailed Description

Definition at line 31 of file contents.h.

## Member Typedef Documentation

## ◆ ColorFilterProc

using impeller::Contents::ColorFilterProc = std::function<Color(Color)>

A procedure that filters a given unpremultiplied color to produce a new unpremultiplied color.

Definition at line 35 of file contents.h.

## ◆ CoverageProc

using impeller::Contents::CoverageProc = std::function<std::optional<Rect>(const Entity& entity)>

Definition at line 58 of file contents.h.

## ◆ RenderProc

using impeller::Contents::RenderProc = std::function<bool(const ContentContext& renderer, const Entity& entity, RenderPass& pass)>

Definition at line 57 of file contents.h.

## Constructor & Destructor Documentation

## ◆ Contents()

impeller::Contents::Contents | ( |  | ) |
| default

## ◆ ~Contents()

impeller::Contents::~Contents | ( |  | ) |
| virtualdefault

## Member Function Documentation

## ◆ ApplyColorFilter()

bool impeller::Contents::ApplyColorFilter | ( | const ColorFilterProc & | color_filter_proc | ) |
| virtual

If possible, applies a color filter to this contents inputs on the CPU.

This method will either fully apply the color filter or perform no action. Partial/incorrect application of the color filter will never occur.

Parameters

  [in] | color_filter_proc | A function that filters a given unpremultiplied color to produce a new unpremultiplied color.

Returns
  True if the color filter was able to be fully applied to all all relevant inputs. Otherwise, this operation is a no-op and false is returned.

Reimplemented in impeller::SolidRRectBlurContents, impeller::SolidColorContents, impeller::SweepGradientContents, impeller::LinearGradientContents, impeller::RadialGradientContents, and impeller::ConicalGradientContents.

Definition at line 145 of file contents.cc.

146 {
147 return false;
148 }

## ◆ AsBackgroundColor()

std::optional< Color > impeller::Contents::AsBackgroundColor | ( | const Entity & | entity,
|  | ISize | target_size
| ) |  | const
| virtual

Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation.

This is useful for absorbing full screen solid color draws into subpass clear colors.

Reimplemented in impeller::SolidColorContents.

Definition at line 136 of file contents.cc.

137 {
138 return {};
139 }

## ◆ AsFilter()

const FilterContents * impeller::Contents::AsFilter | ( |  | ) | const
| virtual

Cast to a filter. Returns `nullptr` if this Contents is not a filter.

Reimplemented in impeller::FilterContents.

Definition at line 141 of file contents.cc.

141 {
142 return nullptr;
143 }

## ◆ GetClipCoverage()

Contents::ClipCoverage impeller::Contents::GetClipCoverage | ( | const Entity & | entity,
|  | const std::optional< Rect > & | current_clip_coverage
| ) |  | const
| virtual

Given the current pass space bounding rectangle of the clip buffer, return the expected clip coverage after this draw call. This should only be implemented for contents that may write to the clip buffer.

During rendering, coverage coordinates count pixels from the top left corner of the framebuffer.

Reimplemented in impeller::ClipRestoreContents, and impeller::ClipContents.

Definition at line 56 of file contents.cc.

58 {
59 return {.type = ClipCoverage::Type::kNoChange,
60 .coverage = current_clip_coverage};
61 }

References impeller::Contents::ClipCoverage::kNoChange, and impeller::Contents::ClipCoverage::type.

## ◆ GetColorSourceSize()

std::optional< Size > impeller::Contents::GetColorSourceSize | ( |  | ) | const

Return the color source's intrinsic size, if available.

        For example, a gradient has a size based on its end and beginning
        points, ignoring any tiling. Solid colors and runtime effects have
        no size.

Definition at line 158 of file contents.cc.

158 {
159 return color_source_size_;
160 };

## ◆ GetCoverage()

virtual std::optional<Rect> impeller::Contents::GetCoverage | ( | const Entity & | entity | ) | const
| pure virtual

Get the area of the render pass that will be affected when this contents is rendered.

During rendering, coverage coordinates count pixels from the top left corner of the framebuffer.

Returns
  The coverage rectangle. An `std::nullopt` result means that rendering this contents has no effect on the output color.

Implemented in impeller::FilterContents, impeller::ColorSourceContents, impeller::ClipRestoreContents, impeller::TextContents, impeller::TextureContents, impeller::AtlasContents, impeller::VerticesSimpleBlendContents, impeller::SolidRRectBlurContents, impeller::SolidColorContents, impeller::AnonymousContents, and impeller::ClipContents.

Referenced by RenderToSnapshot().

## ◆ GetCoverageHint()

const std::optional< Rect > & impeller::Contents::GetCoverageHint | ( |  | ) | const

Definition at line 154 of file contents.cc.

154 {
155 return coverage_hint_;
156 }

Referenced by impeller::FilterContents::Render().

## ◆ IsOpaque()

bool impeller::Contents::IsOpaque | ( | const Matrix & | transform | ) | const
| virtual

Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity.

Parameters

  transform | The current transform matrix of the entity that will render this contents.

Reimplemented in impeller::TiledTextureContents, impeller::SolidColorContents, impeller::SweepGradientContents, impeller::LinearGradientContents, and impeller::RadialGradientContents.

Definition at line 52 of file contents.cc.

52 {
53 return false;
54 }

Referenced by impeller::testing::TEST_P().

## ◆ MakeAnonymous()

std::shared_ptr< Contents > impeller::Contents::MakeAnonymous | ( | Contents::RenderProc | render_proc,
|  | Contents::CoverageProc | coverage_proc
| ) |  |
| static

Definition at line 41 of file contents.cc.

43 {
44 return AnonymousContents::Make(std::move(render_proc),
45 std::move(coverage_proc));
46 }

References impeller::AnonymousContents::Make().

## ◆ Render()

virtual bool impeller::Contents::Render | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| pure virtual

Implemented in impeller::FilterContents, impeller::ClipRestoreContents, impeller::TextureContents, impeller::TextContents, impeller::AtlasContents, impeller::VerticesSimpleBlendContents, impeller::SolidRRectBlurContents, impeller::SolidColorContents, impeller::ClipContents, impeller::TiledTextureContents, impeller::RuntimeEffectContents, impeller::SweepGradientContents, impeller::LinearGradientContents, impeller::RadialGradientContents, impeller::ConicalGradientContents, and impeller::AnonymousContents.

## ◆ RenderToSnapshot()

std::optional< Snapshot > impeller::Contents::RenderToSnapshot | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | std::optional< Rect > | coverage_limit = `std::nullopt`,
|  | const std::optional< SamplerDescriptor > & | sampler_descriptor = `std::nullopt`,
|  | bool | msaa_enabled = `true`,
|  | int32_t | mip_count = `1`,
|  | const std::string & | label = `"Snapshot"`
| ) |  | const
| virtual

Render this contents to a snapshot, respecting the entity's transform, path, clip depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`.

Reimplemented in impeller::TiledTextureContents, impeller::TextureContents, and impeller::FilterContents.

Definition at line 63 of file contents.cc.

70 {
71 auto coverage = GetCoverage(entity);
72 if (!coverage.has_value()) {
73 return std::nullopt;
74 }
75
76 std::shared_ptr<CommandBuffer> command_buffer =
77 renderer.GetContext()->CreateCommandBuffer();
78 if (!command_buffer) {
79 return std::nullopt;
80 }
81
82 // Pad Contents snapshots with 1 pixel borders to ensure correct sampling
83 // behavior. Not doing so results in a coverage leak for filters that support
84 // customizing the input sampling mode. Snapshots of contents should be
85 // theoretically treated as infinite size just like layers.
86 coverage = coverage->Expand(1);
87
88 if (coverage_limit.has_value()) {
89 coverage = coverage->Intersection(*coverage_limit);
90 if (!coverage.has_value()) {
91 return std::nullopt;
92 }
93 }
94
95 ISize subpass_size = ISize::Ceil(coverage->GetSize());
96 fml::StatusOr<RenderTarget> render_target = renderer.MakeSubpass(
97 label, subpass_size, command_buffer,
98 [&contents = *this, &entity, &coverage](const ContentContext& renderer,
99 RenderPass& pass) -> bool {
100 Entity sub_entity;
101 sub_entity.SetBlendMode(BlendMode::kSourceOver);
102 sub_entity.SetTransform(
103 Matrix::MakeTranslation(Vector3(-coverage->GetOrigin())) *
104 entity.GetTransform());
105 return contents.Render(renderer, sub_entity, pass);
106 },
107 msaa_enabled, /*depth_stencil_enabled=*/true,
108 std::min(mip_count, static_cast<int32_t>(subpass_size.MipCount())));
109
110 if (!render_target.ok()) {
111 return std::nullopt;
112 }
113 if (!renderer.GetContext()
114 ->GetCommandQueue()
115 ->Submit(/*buffers=*/{std::move(command_buffer)})
116 .ok()) {
117 return std::nullopt;
118 }
119
120 auto snapshot = Snapshot{
121 .texture = render_target.value().GetRenderTargetTexture(),
122 .transform = Matrix::MakeTranslation(coverage->GetOrigin()),
123 };
124 if (sampler_descriptor.has_value()) {
125 snapshot.sampler_descriptor = sampler_descriptor.value();
126 }
127
128 return snapshot;
129 }

References impeller::TSize< T >::Ceil(), impeller::ContentContext::GetContext(), GetCoverage(), impeller::Entity::GetTransform(), impeller::kSourceOver, impeller::ContentContext::MakeSubpass(), impeller::Matrix::MakeTranslation(), impeller::Entity::SetBlendMode(), impeller::Entity::SetTransform(), subpass_size, and impeller::Snapshot::texture.

Referenced by impeller::TiledTextureContents::RenderToSnapshot(), and impeller::TextureContents::RenderToSnapshot().

## ◆ SetColorSourceSize()

void impeller::Contents::SetColorSourceSize | ( | Size | size | ) |

Definition at line 162 of file contents.cc.

162 {
163 color_source_size_ = size;
164 }

## ◆ SetCoverageHint()

void impeller::Contents::SetCoverageHint | ( | std::optional< Rect > | coverage_hint | ) |

Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`.

Definition at line 150 of file contents.cc.

150 {
151 coverage_hint_ = coverage_hint;
152 }

## ◆ SetInheritedOpacity()

void impeller::Contents::SetInheritedOpacity | ( | Scalar | opacity | ) |
| virtual

Inherit the provided opacity.

       Use of this method is invalid if CanAcceptOpacity returns false.

Reimplemented in impeller::ColorSourceContents, impeller::ClipRestoreContents, impeller::TextureContents, impeller::TextContents, and impeller::ClipContents.

Definition at line 131 of file contents.cc.

131 {
132 VALIDATION_LOG << "Contents::SetInheritedOpacity should never be called when "
133 "Contents::CanAcceptOpacity returns false.";
134 }

References VALIDATION_LOG.

The documentation for this class was generated from the following files:

- impeller/entity/contents/contents.h
- impeller/entity/contents/contents.cc

impeller::ISize
ISize64 ISize
Definition: size.h:140
impeller::Contents::GetCoverage
virtual std::optional< Rect > GetCoverage(const Entity &entity) const =0
Get the area of the render pass that will be affected when this contents is rendered.
impeller::TSize::Ceil
constexpr TSize Ceil() const
Definition: size.h:96
impeller::Matrix::MakeTranslation
static constexpr Matrix MakeTranslation(const Vector3 &t)
Definition: matrix.h:95
subpass_size
ISize subpass_size
The output size of the down-sampling pass.
Definition: gaussian_blur_filter_contents.cc:201
VALIDATION_LOG
#define VALIDATION_LOG
Definition: validation.h:91
impeller::Contents::ClipCoverage::Type::kNoChange
@ kNoChange
impeller::BlendMode::kSourceOver
@ kSourceOver
impeller::AnonymousContents::Make
static std::shared_ptr< Contents > Make(RenderProc render_proc, CoverageProc coverage_proc)
Definition: anonymous_contents.cc:11